
/*
 * Updated: 9th August 2004
 */

#include <stdio.h>
#define RECLS_OVERRIDE_PLATFORM
#define RECLS_PURE_API
//#define WIN32
//#define RECLS_PLATFORM_IS_WIN32
#include <recls.h>

/* /////////////////////////////////////////////////////////////////////////////
 * Macros
 */

#ifndef NUM_ELEMENTS
# define NUM_ELEMENTS(x)        (sizeof(x) / sizeof((x)[0]))
#endif /* !NUM_ELEMENTS */

/* /////////////////////////////////////////////////////////////////////////////
 * Main
 */

int main(int argc, char *argv[])
{
	if(argc < 3)
	{
		printf("No argument(s) specified\n");
	}
	else
	{
		char const			*rootDir	=	argv[1];
		char const			*pattern	=	argv[2];
		recls_rc_t			rc;
		unsigned			flags		=	0;
		hrecls_t			hSrch;

		flags |= RECLS_F_RECURSIVE;
		flags |= RECLS_F_DIRECTORY_PARTS;

		printf("Root-dir: %s\n", rootDir);
		printf("Pattern:  %s\n", pattern);
		printf("Flags:    0x%08x\n", flags);

		rc = Recls_Search(rootDir, pattern, flags, &hSrch);

		if(RECLS_FAILED(rc))
		{
			char	sz[201];

			Recls_GetErrorString(rc, &sz[0], 201);

			printf("Search failed: %s\n", sz);

			return 1;
		}
		else
		{
	        recls_info_t    entry;

    	    rc = Recls_GetDetails(hSrch, &entry);

        	for(; RECLS_SUCCEEDED(rc); rc = Recls_GetNextDetails(hSrch, &entry))
	        {
				char	szPath[301];
				char	szDirectory[301];
				char	szDirectoryPath[301];
				char	szFile[301];
				size_t	numParts	=	Recls_GetDirectoryPartProperty(entry, -1, NULL, 0);
				size_t	j;

				Recls_GetPathProperty(entry, &szPath[0], NUM_ELEMENTS(szPath));
				Recls_GetDirectoryProperty(entry, &szDirectory[0], NUM_ELEMENTS(szDirectory));
				Recls_GetDirectoryPathProperty(entry, &szDirectoryPath[0], NUM_ELEMENTS(szDirectoryPath));
				Recls_GetFileProperty(entry, &szFile[0], NUM_ELEMENTS(szFile));

				puts("");
				printf("  %s\n", szPath);
				printf("  %s\n", szDirectory);
				printf("  %s\n", szDirectoryPath);
				printf("  %s\n", szFile);
				for(j = 0; j < numParts; ++j)
				{
					char	szPart[301];

					Recls_GetDirectoryPartProperty(entry, j, &szPart[0], NUM_ELEMENTS(szPart));

					printf("    %d: %s\n", j, szPart);
				}
			}

			Recls_SearchClose(hSrch);
		}
	}

	return 0;
}

/* //////////////////////////////////////////////////////////////////////////
 * End of file
 */

