/* /////////////////////////////////////////////////////////////////////////////
 * File:        recls_string.h
 *
 * Purpose:     Implementation header.
 *
 * Created:     12th March 2005
 * Updated:     19th May 2005
 *
 * Home:        http://recls.org/
 *
 * Copyright 2005, Matthew Wilson and Synesis Software
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted in accordance with the license and warranty
 * information described in recls.h (included in this distribution, or available
 * from http://recls.org/)
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef RECLS_INCL_H_RECLS_STRING
#define RECLS_INCL_H_RECLS_STRING

/* File version */
#ifndef RECLS_DOCUMENTATION_SKIP_SECTION
# define RECLS_VER_H_RECLS_STRING_MAJOR     1
# define RECLS_VER_H_RECLS_STRING_MINOR     1
# define RECLS_VER_H_RECLS_STRING_REVISION  2
# define RECLS_VER_H_RECLS_STRING_EDIT      6
#endif /* !RECLS_DOCUMENTATION_SKIP_SECTION */

/** \file recls_string.h Implementation header.
 */

/* /////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#include <recls.h>

//#define RECLS_NO_USE_SIMPLE_STRING

#ifndef RECLS_NO_USE_SIMPLE_STRING

# include <stlsoft/simple_string.hpp>

# define    RECLS_STRING_TEMPLATE_1(T)  stlsoft_ns_qual(basic_simple_string)<T>

# define    STLSOFT_STRING_ACCESS_NO_STD_STRING /* We don't care about std::string in recls */

#else /* ? USE_STRING_VIEW_FOR_PATTERN_SEARCH */

# include <string>

# define    RECLS_STRING_TEMPLATE_1(T)  stlsoft_ns_qual_std(basic_string)<T>

#endif /* !RECLS_NO_USE_SIMPLE_STRING */

#include <stlsoft/string_access.hpp>

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* !RECLS_INCL_H_RECLS_STRING */

/* ////////////////////////////////////////////////////////////////////////// */
